#!/bin/bash
#
# patch-to-non-smp.sh
#
# This script converts the header and kernel files from SMP (which is
# now default on Slackware) to non-SMP.
#
# Copyright 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2019  Patrick Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
#  EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# Set initial variables:
CWD=$(pwd)

KERNEL=${KERNEL:-5.18.14}
BUILD=${BUILD:-1}

# Probably this should not be installed, since the other header package
# is more closely matched to glibc.
#upgradepkg --install-new kernel-headers-${KERNEL}-*-${BUILD}.tgz

( cd /usr/src/linux-$(echo ${KERNEL} | tr _ - | sed "s/\.0$//g" | sed "s/\.0-/-/g")
  zcat $CWD/linux-${KERNEL}-smp-to-nosmp.diff.gz | patch -p1 )
if [ ! $? = 0 ]; then
  echo "FATAL:  kernel not found in /usr/src/linux-$(echo ${KERNEL} | tr _ - | sed "s/\.0$//g" | sed "s/\.0-/-/g") or patch failed"
  echo "        Make sure you have a fresh, unmodified Slackware kernel"
  echo "        package installed."
fi

